<?php defined('SYSPATH') or die('No direct script access.');

class Model_Klachten extends Kohana_Model
{
	public function getReden()
	{
		$sql="SELECT redenid as id, omschrijving as naam
				FROM klachtreden
				WHERE (binapp & 1); ";
		$query =  DB::query(Database::SELECT, $sql, FALSE);	
		return $query->execute()->as_array();
	}
	
	public function getInspectie()
	{
		$sql="SELECT inspectieid as id, omschrijving as naam
				FROM klachtinspectie
				WHERE (binapp & 1); ";
		$query =  DB::query(Database::SELECT, $sql, FALSE);	
		return $query->execute()->as_array();
	}
	
	public function getActie()
	{
		$sql="SELECT actieid as id, omschrijving as naam
				FROM klachtactie
				WHERE (binapp & 1); ";
		$query =  DB::query(Database::SELECT, $sql, FALSE);	
		return $query->execute()->as_array();
	}
	
	public function saveKlacht($post)
	{	
		try{
			Database::instance()->begin();
			foreach($post['geg'] as $art){
				$klachtid=$art['klachtid'];
				if(isset($art['klachtartikelid'])){
					if(!isset($art['credit'])){
						$art['credit']=0;
					}
					$sql="UPDATE klachtartikel 
						SET inspectieid=:inspectie, credit=:credit, actieid=:actieid, aantalstuks=:aantal, aantaleenheden=:eenheden
						WHERE klachtartikelid=:klachtartikelid";
					$query=DB::query(Database::UPDATE, $sql, FALSE)
						->parameters(array(':inspectie'=>$art['inspectie'],
									':credit'=>$art['credit'],
									':actieid'=>$art['actie'],
									':aantal'=>$art['aantal'],
									':eenheden'=>$art['eenheden'],
									':klachtartikelid'=>$art['klachtartikelid']));
					$query->execute();
				}
				if(isset($art['klachtleeggoedid'])){
					$sql="UPDATE klachtleeggoed
						SET  aantalstuks=:aantal
						WHERE klachtleeggoedid=:klachtleeggoedid";
					$query=DB::query(Database::UPDATE, $sql, FALSE)
						->parameters(array(':aantal'=>$art['aantal'],':klachtleeggoedid'=>$art['klachtleeggoedid']));
					$query->execute();
				}
			}

			$sql="UPDATE klacht 
					SET inspecteur=:contact, opmerking=:opmerking, afgehandeld=curdate() 
					WHERE klachtid=:klachtid";
			$query=DB::query(Database::UPDATE, $sql, FALSE)
				->parameters(array(':contact'=>$_SESSION['VMI']['contactid'],
									':opmerking'=>$post['opmerking'],
									':klachtid'=>$klachtid));
			$query->execute();	
			
			//MAIL STUREN NAAR LEVERANCIER
			$tomail=Kohana::$config->load('appconf.tomail');
			
			
			$db = $this->getDetailKlacht($klachtid);
			$mdlLev=new Model_Leverancier();
			$contacten=$mdlLev->getContactenLeverancierMail($db['klacht'][0]['leverancierid'],2);
			$mail=$contacten['mail'];
			if(!empty($mail) && (isset($post['sendmail']) && $post['sendmail']==1)){
				$tomail=array();
				$tomail=array_unique(explode(",",rtrim($mail,",")));
				$mdl=new Model_Mail();
				$mdl->setTo($tomail);
				$mdl->setBcc(array("purchase.direct@greenyardfresh.be","administratie.direct@greenyardfresh.be"));
				$mdl->mailKlachtLeverancier($db);
			}else{
				$mdl=new Model_Mail();
				$mdl->setTo(array("purchase.direct@greenyardfresh.be"));
				$mdl->setBcc(array("administratie.direct@greenyardfresh.be"));
				$mdl->mailKlachtLeverancier($db);
			}

			Database::instance()->commit();
			$response['success']=true;
			$response['titel']="Info";
			$response['message']="Gegevens zijn opgeslagen.";
		}catch(Exception $e)
		{
			Database::instance()->rollback();
			$response['success'] = false;
			$response['titel']="Error";
			$response['message'] = $e->getMessage();
			Log::instance()->add(Log::ERROR, $e->getMessage());	
		}
	
		return $response;
	}
	
	public function setKlacht($gegevens)
	{
		try{
			Database::instance()->begin();
			if($gegevens['files']==null){ $gegevens['files']=NULL; }
			
			$sql = "INSERT INTO klacht (soort, registrator, externe, opmerking, gemeld, aangemaakt,docs)
					VALUES (1, :registrator, :levid,:opm,1, curdate(),:docs)";
			$query =  DB::query(Database::INSERT, $sql, FALSE)
						->parameters(array(':registrator'=>$_SESSION['VMI']['contactid'],':levid'=>$gegevens['leverancierid'],':opm'=>$gegevens['opmerking'],':docs'=>str_replace("<br>","",$gegevens['files']) ));
			$db=$query->execute();
			$klachtid=$db[0];	
			
			foreach($gegevens['artikels'] as $art){
				$sql = "INSERT INTO klachtartikel (klachtid, levering, artikelid, aantalstuks, aantaleenheden, prijs, redenid)
					VALUES (:klachtid, :levering, :artikelid,:stuks,:eenheden,:prijs, :reden)";
				$query =  DB::query(Database::INSERT, $sql, FALSE)
						->parameters(array(':klachtid'=>$klachtid,
										':levering'=>$art['levbon'],
										':artikelid'=>$art['artikelid'],
										':stuks'=>$art['aantal'],
										':eenheden'=>$art['eenheid'],
										':prijs'=>$art['prijs'],
										':reden'=>$art['reden']));	
				$query->execute();
			}
			
			if(isset($gegevens['leeggoed'])){
				foreach($gegevens['leeggoed'] as $lg){
					$sql = "INSERT INTO klachtleeggoed (klachtid, leeggoedid, aantalstuks)
						VALUES (:klachtid, :leeggoedid,:stuks)";
					$query =  DB::query(Database::INSERT, $sql, FALSE)
							->parameters(array(':klachtid'=>$klachtid,':leeggoedid'=>$lg['leeggoedid'],':stuks'=>$lg['aantal']));	
					$query->execute();
				}
			}

			Database::instance()->commit();
			$result['success']=TRUE;
			$response['titel']="Info";
			$result['message']="Klacht (ref: ".$klachtid.") is toegevoegd.";
		}catch(Exception $error){
			Database::instance()->rollback();
			$result['success']=FALSE;
			$response['titel']="Error";
			$result['message']=$error->getMessage();
			Log::instance()->add(Log::ERROR, $error->getMessage());	
		}	
		return $result;
	}
	
	public function getDetailKlacht($klachtid)
	{
		try {
			$sql="SELECT k.klachtid, kart.klachtartikelid, l.leverancierid, CONVERT(CONCAT(k.externe,' ',l.naam)using latin1) as leverancier, concat( c.naam,' ',c.voornaam) as registrator, concat( c2.naam,' ',c2.voornaam) as inspecteur, 
				date_format(k.aangemaakt,'%d-%m-%Y') as aangemaakt, date_format(k.afgehandeld,'%d-%m-%Y') as afgehandeld, k.opmerking, k.docs,
				IF(k.afgehandeld is null,'Open' ,IF(kart.credit=0,'Niet-gecrediteerd','Gecrediteerd')) as status,
				kart.artikelid, ao.omschrijving as artikelomschrijving, CONVERT(concat(kart.artikelid,' ',ao.omschrijving)using latin1) as artikel, CONVERT(concat(IFNULL(la.code,''),' ',IFNULL(la.informatie,''))using latin1) as artikellev,
				kart.prijs, kart.aantalstuks, kart.aantaleenheden as eenheid, 
				reden.omschrijving as reden, IFNULL(insp.omschrijving,'') as inspectie, IFNULL(actie.omschrijving,'') as actie, levering, IFNULL(bl.leveringsnr,'-') as levleveringsnr, date_format(IFNULL(bl.leveringvan,bl.bestelleveringvan),'%d-%m-%Y') as leveringvan, docs as docs,
				IFNULL(l.straatnr,'') as straatnr, IFNULL(l.postcode,'') as postcode, IFNULL(l.plaats,'') as plaats
				FROM klacht k 
				LEFT JOIN klachtartikel kart ON k.klachtid=kart.klachtid
				LEFT JOIN contact c ON c.contactid=k.registrator
				LEFT JOIN contact c2 ON c2.contactid=k.inspecteur
				LEFT JOIN leverancier l ON l.leverancierid=k.externe
				LEFT JOIN artikelomschrijving ao ON ao.artikelid=kart.artikelid AND ao.taalid=1 
				LEFT JOIN leverancierartikel la ON la.leverancierid=k.externe and la.artikelid=kart.artikelid
				LEFT JOIN klachtreden reden ON reden.redenid=kart.redenid
				LEFT JOIN klachtinspectie insp ON insp.inspectieid=kart.inspectieid
				LEFT JOIN klachtactie actie ON actie.actieid=kart.actieid
				LEFT JOIN bestellingleverancier bl ON bl.bestelid=kart.levering
				WHERE k.klachtid=:klachtid ";
			$query =  DB::query(Database::SELECT, $sql, FALSE)
					->parameters(array(':klachtid'=>$klachtid));
			$db= $query->execute()->as_array();
		
			$klachtdetail = array();
			if(isset($db[0])){
				$klachtdetail['klacht']=$db;
			}
		
			$sql="SELECT k.klachtid, kart.klachtleeggoedid, l.omschrijving, IFNULL(ll.prijs,l.prijs) as prijs, kart.aantalstuks
					FROM klacht k 
					LEFT JOIN klachtleeggoed kart ON k.klachtid=kart.klachtid
					LEFT JOIN leeggoed l ON l.leeggoedid=kart.leeggoedid
					LEFT JOIN leverancierleeggoed ll ON ll.leeggoedid=kart.leeggoedid AND k.externe=ll.leverancierid
					WHERE k.klachtid=:klachtid " ;
			$query =  DB::query(Database::SELECT, $sql, FALSE)->parameters(array(':klachtid'=>$klachtid));
			$db= $query->execute()->as_array();
			if(isset($db[0])){
				$klachtdetail['leeggoed']=$db;
			}
			return $klachtdetail;
		} catch(Exception $e) {
			Log::instance()->add(Log::ERROR, $e->getMessage());	
			return array();
		}
	}
	
	public function getDataKlachten(){
		$aColumns = array(
			array( 'db' => 'klachtstatus', 'dt' => 'klachtstatus' ),
			array( 'db' => 'datum',  'dt' => 'datum' ),
			array( 'db' => 'klachtid',  'dt' => 'klachtid' ),
			array( 'db' => 'leverancierid',  'dt' => 'leverancierid' ),
			array( 'db' => 'leveranciernaam',   'dt' => 'leveranciernaam' ),
			array( 'db' => 'registrator',   'dt' => 'registrator' ),
			array( 'db' => 'inspecteur',   'dt' => 'inspecteur' ),
			array( 'db' => 'opmerking',   'dt' => 'opmerking',
					 'formatter' => function( $d, $row ) {
						return strip_tags($d);
					})
			
		);
		$sIndexColumn = "klachtid";
		$sTable = " vwKlachtLeverancier ";
		$output = SSPdataTables::dataTables($aColumns,$sIndexColumn,$sTable);
		return $output;
	}
}
?>
