<?php defined('SYSPATH') or die('No direct script access.');

class Model_Leeggoed extends Kohana_Model
{
	public function slLeeggoed()
	{
		try{
			$sql="SELECT leeggoedid as id, CONCAT(prijs,' - ',omschrijving) as naam
					FROM leeggoed WHERE actief=1 ORDER BY volgnummer";
			$query =  DB::query(Database::SELECT, $sql, FALSE)->parameters(array(':levid'=>$_SESSION['VMI']['slLev']));	
			$db=$query->execute()->as_array();
			return $db;
		} catch(Exception $e) {
			Log::instance()->add(Log::ERROR, $e->getMessage());	
			return array();
		}
	}
	
	public function getLeeggoed()
	{
		try{
			$sql="SELECT lg.leeggoedid, lg.omschrijving, lg.omschrijvingKort, lg.prijs as bfprijs, 
				IF(llg.leeggoedid is null, 0,1) as actief, IFNULL(llg.prijs,lg.prijs) as prijs
				FROM leeggoed lg
				LEFT JOIN leverancierleeggoed llg ON llg.leeggoedid=lg.leeggoedid AND llg.leverancierid=:levid
				WHERE lg.actief=1 ORDER BY lg.volgnummer";
			$query =  DB::query(Database::SELECT, $sql, FALSE)->parameters(array(':levid'=>$_SESSION['VMI']['slLev']));	
			$db=$query->execute()->as_array();
			return $db;
		} catch(Exception $e) {
			Log::instance()->add(Log::ERROR, $e->getMessage());	
			return array();
		}
	}
	
	public function getLeeggoedLeverancier()
	{
		try{
			$sql="SELECT l.leeggoedid, l.omschrijving, l.omschrijvingKort, l.prijs as bfprijs, 
				IFNULL(ll.prijs,l.prijs) as prijs, l.artikelid, l.volgnummer 
				FROM leverancierleeggoed ll
              	LEFT JOIN leeggoed l  on l.leeggoedid=ll.leeggoedid 
               	WHERE ll.leverancierid=:levid AND l.actief=1
               	ORDER BY l.volgnummer";
			$query =  DB::query(Database::SELECT, $sql, FALSE)->parameters(array(':levid'=>$_SESSION['VMI']['slLev']));	
			$db=$query->execute()->as_array();
			return $db;
		} catch(Exception $e) {
			Log::instance()->add(Log::ERROR, $e->getMessage());	
			return array();
		}
	}
	
	
	public function setLeeggoedLeverancier($geg)
	{
		try{
			if($geg['actief']==1){
				//nu actief leeggoed met prijs toevoegen
				$sql="INSERT INTO leverancierleeggoed (leverancierid, leeggoedid, prijs) 
						SELECT :levid, leeggoedid, prijs FROM leeggoed WHERE leeggoedid=:leeggoedid";
				$query=DB::query(Database::INSERT, $sql, FALSE)->parameters(array(':levid'=>$_SESSION['VMI']['slLev'],':leeggoedid'=>$geg['leeggoedid']));
				$query->execute();
			}else{
				//niet meer actief verwijderen
				$sql="DELETE FROM leverancierleeggoed WHERE leeggoedid=:leeggoedid AND leverancierid=:levid;";
				$query=DB::query(Database::DELETE, $sql, FALSE)->parameters(array(':levid'=>$_SESSION['VMI']['slLev'],':leeggoedid'=>$geg['leeggoedid']));
				$query->execute();
			}
			$response['success']=true;
			$response['titel']="Info";
			$response['message']="";
		}catch(Exception $error){
			$response['success']=false;
			$response['titel']="Error";
			$response['message']="Er is een fout opgetreden.<br/>Error:".$error->getMessage()."<br/><br/>";
			Log::instance()->add(Log::ERROR, $error->getMessage());	
		}
		return $response;
	}
	
	public function setLeeggoedLeverancierPrijs($geg)
	{
		try{
			$sql="SELECT prijs FROM leverancierleeggoed  WHERE leeggoedid=:leeggoedid AND leverancierid=:levid;";
			$query=DB::query(Database::SELECT, $sql, FALSE)->parameters(array(':levid'=>$_SESSION['VMI']['slLev'],':leeggoedid'=>$geg['leeggoedid']));
			$db=$query->execute()->as_array();
			if(empty($db)){
				//nu actief leeggoed met prijs toevoegen
				$sql="INSERT INTO leverancierleeggoed (leverancierid, leeggoedid, prijs) VALUES (:levid, :leeggoedid, :prijs)";
				$query=DB::query(Database::INSERT, $sql, FALSE)->parameters(array(':levid'=>$_SESSION['VMI']['slLev'],':leeggoedid'=>$geg['leeggoedid'],':prijs'=>$geg['prijs']));
				$query->execute();
			}else{
				//UPDATE 
				$sql="UPDATE leverancierleeggoed SET prijs=:prijs WHERE leeggoedid=:leeggoedid AND leverancierid=:levid;";
				$query=DB::query(Database::DELETE, $sql, FALSE)->parameters(array(':levid'=>$_SESSION['VMI']['slLev'],':leeggoedid'=>$geg['leeggoedid'],':prijs'=>$geg['prijs']));
				$query->execute();
			}
			$response['success']=true;
			$response['titel']="Info";
			$response['message']="";
		}catch(Exception $error){
			$response['success']=false;
			$response['titel']="Error";
			$response['message']="Er is een fout opgetreden.<br/>Error:".$error->getMessage()."<br/><br/>";
			Log::instance()->add(Log::ERROR, $error->getMessage());	
		}
		return $response;
	}
	
	
}
?>
	